% CRP_DEMO2: Less simple demo script for crplus.m
%
% In this example, we model a heterogenous portfolio.

% Percentiles to calculate.  
q=[0.95 0.99 0.995 0.9997]';

N=3000;                   % number of obligors
maxloan=150;              % max loan size (must divide N evenly!)
% Let loss exposures vary from 1 to maxloan.
lossvalue=repmat((1:maxloan)',N/maxloan,1);    % Nx1 vector

% Let the DefProbs vary up to 5 pct
defprob=0.05*rand(N,1);

% Assume two systematic risk factors with std dev:
sigma=[2 1.5];

% Factor loadings for each obligor may sum to less than one.
% Remaining weight will automatically be assigned to specific risk.
w=0.5*rand(N,2);

% Choose crude lossunit
lossunit=10;
disp(sprintf('Analysis using lossunit = %2.0f',lossunit))
[VaR,summarystats,errorcode] ...
     = crplus(defprob,lossvalue,w,sigma,q,lossunit);

% Choose fine lossunit
lossunit=1;
disp(sprintf('Analysis using lossunit = %2.0f',lossunit))
[VaR,summarystats,errorcode] ...
     = crplus(defprob,lossvalue,w,sigma,q,lossunit);
